#ifndef R2C2_3D_TRACKCHAIN_H_
#define R2C2_3D_TRACKCHAIN_H_

#include <msp/gl/color.h>
#include "libr2c2/trackchain.h"

namespace R2C2 {

class Layout3D;
class Path3D;

class TrackChain3D: public sigc::trackable
{
protected:
	typedef std::map<Track *, Path3D *> PathMap;

	Layout3D &layout;
	TrackChain &chain;
	PathMap paths;
	Msp::GL::Color color;
	float layer;

public:
	TrackChain3D(Layout3D &, TrackChain &);
	~TrackChain3D();

	void set_color(const Msp::GL::Color &);
	void set_layer(float);

protected:
	void track_added(Track &);
	void track_removed(Track &);
};

} // namespace R2C2

#endif
