#include "designer.h"
#include "trackbar.h"

using namespace Msp;

Trackbar::Trackbar(Designer &designer):
	Toolbar("Track")
{
	GLtk::Button *btn;

	pnl_content->add(*(btn = new GLtk::Button("New")));
	btn->set_style("green");
	btn->set_tooltip("Add a track piece (N)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::new_object));

	pnl_content->add(*(btn = new GLtk::Button("Del")));
	btn->set_style("red");
	btn->set_tooltip("Delete selected tracks (X)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::erase_objects));

	pnl_content->add(*(btn = new GLtk::Button("Prop")));
	btn->set_tooltip("Change properties of selected tracks (P)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::object_properties));

	pnl_content->add(*(btn = new GLtk::Button("Xtnd")));
	btn->set_tooltip("Extend straight track out of free endpoint (Shift+N)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::extend_track));

	pnl_content->add(*(btn = new GLtk::Button("Conn")));
	btn->set_tooltip("Connect free endpoints of selected tracks (C)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::connect_tracks));

	pnl_content->add(*(btn = new GLtk::Button("Flat")));
	btn->set_tooltip("Make selected tracks flat (F)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::flatten_tracks));
}
