#ifndef CLOCKDIALOG_H_
#define CLOCKDIALOG_H_

#include <msp/gltk/entry.h>
#include <msp/gltk/indicator.h>
#include "libr2c2/clock.h"
#include "dynamicdialog.h"

class ClockWidget;
class Engineer;

class ClockDialog: public DynamicDialog, public sigc::trackable
{
private:
	R2C2::Clock &clock;
	Msp::GLtk::Entry *ent_rate;
	Msp::GLtk::Indicator *ind_stopped;
	Msp::GLtk::Entry *ent_hour;
	Msp::GLtk::Entry *ent_minute;

public:
	ClockDialog(Engineer &);

private:
	void update_time();
	void set_rate();
	void stop_clicked();
	void set_time();

public:
	virtual bool save_state(Msp::DataFile::Statement &) const;
};

#endif
