#ifndef LIBR2C2_BEAMGATE_H_
#define LIBR2C2_BEAMGATE_H_

#include "beamgatetype.h"
#include "sensor.h"
#include "trackattachment.h"

namespace R2C2 {

class BeamGate: public TrackAttachment, public Sensor
{
public:
	class Loader: public Msp::DataFile::ObjectLoader<BeamGate>
	{
	public:
		Loader(BeamGate &);
	private:
		void address(unsigned);
		void position(float, float, float);
		void rotation(float);
	};

	BeamGate(Layout &);
	virtual ~BeamGate();

	virtual BeamGate *clone(Layout * = 0) const;
	virtual const BeamGateType &get_type() const;

	virtual void set_position(const Vector &);
	virtual void set_rotation(const Angle &);
	virtual void set_tilt(const Angle &) { }
private:
	void update_attachment();

public:
	virtual Block *get_block() const;

	void save(std::list<Msp::DataFile::Statement> &) const;
};

} // namespace R2C2

#endif
